// JavaScript Document
function Cconfig(width){
	//screen size & aspect ratio
	this.Vwidth=width;

	this.VwidthOrig=720;
	this.VheightOrig=500;
	this.aspectRatio=this.Vwidth/this.VwidthOrig;
	this.Vheight=this.VheightOrig*this.aspectRatio;
	
	this.loadingImg='js/games/kayak/assets/images/ui/loading.jpg';
	this.loadingPaddle='js/games/kayak/assets/images/ui/loadingpaddle.png';
	this.flagsImg='js/games/kayak/assets/images/ui/flags.png';
	//images
	this.waterImg='js/games/kayak/assets/images/water.png';
	this.skyImg='js/games/kayak/assets/images/sky.png';
	this.mountainL='js/games/kayak/assets/images/mountain_left.png';
	this.mountainR='js/games/kayak/assets/images/mountain_right.png';
	this.kayakImg='js/games/kayak/assets/images/kayak.png';
	this.kayakWaterImg='js/games/kayak/assets/images/kayak water.png';
	this.kayakUpsideDown='js/games/kayak/assets/images/turned over kayak.png';
	this.paddleImg='js/games/kayak/assets/images/paddle.png';
	this.finishImg='js/games/kayak/assets/images/finish line.png';

	this.redBodyImg='js/games/kayak/assets/images/red/body.png';
	this.redArmImg='js/games/kayak/assets/images/red/arm.png';
	this.redFarmImg='js/games/kayak/assets/images/red/forearm.png';
	this.redManWater='js/games/kayak/assets/images/red/inwater.png';

	this.purpleBodyImg='js/games/kayak/assets/images/purple/body.png';
	this.purpleArmImg='js/games/kayak/assets/images/purple/arm.png';
	this.purpleFarmImg='js/games/kayak/assets/images/purple/forearm.png';
	this.purpleManWater='js/games/kayak/assets/images/purple/inwater.png';
	
	this.iceSky='js/games/kayak/assets/images/ice/iceSky.png';
	this.iceWater='js/games/kayak/assets/images/ice/iceWater.png';
	this.iceLeft='js/games/kayak/assets/images/ice/iceLeft.png';
	this.iceRight='js/games/kayak/assets/images/ice/iceRight.png';
	this.iceRock1='js/games/kayak/assets/images/ice/iceInwater1.png';
	this.iceRock2='js/games/kayak/assets/images/ice/iceInwater2.png';
	
	this.greenBack='js/games/kayak/assets/images/green/backMountains.png';
	this.greenLeft='js/games/kayak/assets/images/green/leftSide.png';
	this.greenRight='js/games/kayak/assets/images/green/rightSide.png';
	this.greenTree1='js/games/kayak/assets/images/green/tree.png';
	this.greenTree2='js/games/kayak/assets/images/green/tree2.png';
	this.greenWater='js/games/kayak/assets/images/green/water.png';

	this.rocksSky='js/games/kayak/assets/images/rocky/rcokSky.png';
	this.rocksWater='js/games/kayak/assets/images/rocky/ROckWater.png';
	this.rocksBoulder1='js/games/kayak/assets/images/rocky/rock1.png';
	this.rocksBoulder2='js/games/kayak/assets/images/rocky/rock2.png';
	this.rocksBoulder3='js/games/kayak/assets/images/rocky/rock3.png';
	this.rocksBoulder4='js/games/kayak/assets/images/rocky/rock4.png';
	this.rocksBoulderEnd='js/games/kayak/assets/images/rocky/rockEnd.png';
	this.rocksFinishLine='js/games/kayak/assets/images/rocky/finishLine.png';
	
	this.nightSky='js/games/kayak/assets/images/night/startSky.png';
	this.nightWater='js/games/kayak/assets/images/night/NightSea.png';
	this.nightLMountain='js/games/kayak/assets/images/night/Left-mountainNIGHT.png';
	this.nightRMountain='js/games/kayak/assets/images/night/right mountainNIGHT.png';

	this.preload=[
	'js/games/kayak/assets/images/ui/menu.jpg',
	'js/games/kayak/assets/images/ui/flags.png',
	'js/games/kayak/assets/images/ui/banner menus.png',
	'js/games/kayak/assets/images/ui/bannerStick.png',
	'js/games/kayak/assets/images/ui/box.png',
	'js/games/kayak/assets/images/ui/whiteBox1.png'
	];


	this.screens=[
		{
		LmountainStartX:-17,
		LmountainStartY:110,
		LmountainStartZ:0.10,
		LmountainEndX:-3010,
		LmountainEndY:-1270,
		LmountainEndZ:1.0,

		RmountainStartX:420,
		RmountainStartY:105,
		RmountainStartZ:0.103,
		RmountainEndX:420,
		RmountainEndY:-1320,
		RmountainEndZ:1.0,

		finishStartX:300,
		finishStartY:210,
		finishStartZ:0.15,
		finishEndX:0,
		finishEndY:100,
		finishEndZ:1.0,

		rocksSW:50,
		rocksEW:200,
		rocksDeltaX:15,
		rocksDeltaEX:80,
		rocksDeltaY:20,
		rocksSY:280,
		rocksEY:380,
		kayakStartY:290,
		Wave00:'js/games/kayak/assets/images/waves/1.png',
		Wave01:'js/games/kayak/assets/images/waves/2.png',
		Wave02:'js/games/kayak/assets/images/waves/3.png',
		Rock01:'js/games/kayak/assets/images/rocks/greenrock1.png',
		Rock02:'js/games/kayak/assets/images/rocks/greenrock2.png'
		},
		{
		LmountainStartX:-5,
		LmountainStartY:60,
		LmountainStartZ:0.28,
		LmountainEndX:-950,
		LmountainEndY:-150,
		LmountainEndZ:1.0,

		RmountainStartX:320,
		RmountainStartY:60,
		RmountainStartZ:0.28,
		RmountainEndX:220,
		RmountainEndY:-150,
		RmountainEndZ:1.0,

		finishStartX:300,
		finishStartY:210,
		finishStartZ:0.15,
		finishEndX:0,
		finishEndY:100,
		finishEndZ:1.0,

		rocksSW:30,
		rocksEW:350,
		rocksDeltaX:0,
		rocksDeltaEX:0,
		rocksDeltaY:20,
		rocksSY:150,
		rocksEY:240,
		kayakStartY:230
		},
		{
		BmountainStartX:-17,
		BmountainStartY:20,
		BmountainStartZ:0.18,
		BmountainEndX:-1710,
		BmountainEndY:-570,
		BmountainEndZ:1.0,

		LmountainStartX:-17,
		LmountainStartY:70,
		LmountainStartZ:0.34,
		LmountainEndX:-810,
		LmountainEndY:-116,
		LmountainEndZ:1.0,

		RmountainStartX:370,
		RmountainStartY:70,
		RmountainStartZ:0.34,
		RmountainEndX:480,
		RmountainEndY:-116,
		RmountainEndZ:1.0,

		finishStartX:300,
		finishStartY:210,
		finishStartZ:0.15,
		finishEndX:0,
		finishEndY:100,
		finishEndZ:1.0,
		
		waterSX:0,
		waterSZ:1.0,
		waterEX:-1690,
		waterEZ:5.7,

		rocksSW:30,
		rocksEW:400,
		rocksEDeltaW:120,
		rocksDeltaX:0,
		rocksDeltaEX:0,
		rocksDeltaY:0,
		rocksSY:165,
		rocksEY:165,
		kayakStartY:230,
		},
		{
		LmountainStartX:350,
		LmountainStartY:145,
		LmountainStartZ:0.15,
		LmountainEndX:210,
		LmountainEndY:110,
		LmountainEndZ:1.0,

		RmountainStartX:387,
		RmountainStartY:145,
		RmountainStartZ:0.15,
		RmountainEndX:420,
		RmountainEndY:110,
		RmountainEndZ:1.0,

		finishStartX:355,
		finishStartY:142,
		finishStartZ:0.125,
		finishEndX:245,
		finishEndY:95,
		finishEndZ:0.7,
		
		waterSX:0,
		waterSZ:1.0,
		waterEX:-1690,
		waterEZ:5.7,

		rocksSW:50,
		rocksEW:200,
		rocksDeltaX:15,
		rocksDeltaEX:80,
		rocksDeltaY:0,
		rocksSY:150,
		rocksEY:250,
		kayakStartY:230
		},
		{
		LmountainStartX:-5,
		LmountainStartY:20,
		LmountainStartZ:0.2,
		LmountainEndX:-1010,
		LmountainEndY:-430,
		LmountainEndZ:1.0,

		RmountainStartX:490,
		RmountainStartY:20,
		RmountainStartZ:0.2,
		RmountainEndX:420,
		RmountainEndY:-430,
		RmountainEndZ:1.0,

		finishStartX:300,
		finishStartY:80,
		finishStartZ:0.15,
		finishEndX:110,
		finishEndY:80,
		finishEndZ:0.7,
		kayakStartY:230
		}
	]

	//motion paths

	this.kayakStartX=340;
	this.kayakStartY=290;
	this.kayakStartZ=0.55;
	this.kayakEndX=270;
	this.kayakEndY=500;
	this.kayakEndZ=1.0;
	this.kayakWaterX=10;
	this.kayakWaterY=30;
	this.kayakBodyX=26;
	this.kayakBodyY=-4;
	this.kayakPaddleX=-19;
	this.kayakPaddleY=11;
	this.kayakLFArmX=10;
	this.kayakLFArmY=6;
	this.kayakLArmX=12;
	this.kayakLArmY=15;
	this.kayakRFArmX=30;
	this.kayakRArmX=32;
	this.kayakLPX=31;
	this.kayakLPY=20;
	this.kayakRPX=51;
	

	//game speeds
	this.renderSpeed=20;//miliseconds between screen refreshes
	this.kayakSpeed=0.01;//speed at which the kayak moves(animation only)
	this.upRiver=1.0;//do not change
	
	this.fileConfig=false;
	this.kayakUp=false;//wether (and by how much) the kayak moves up for every correct key at the end of a word; false=it moves all the way up
	this.kayakDown=0.1;//how much kayak moves down on a wrong key
	this.riverSpeed=0.001;//how fast the kayak flows down river when no keys are pressed
	this.floatersDown=0.0;//how fast the waves go down river(adjust so they move down at the same speed as the kayak)
	this.scoreDiff=0.02;//how much a diiference in score affects the other kayak
	
	this.mockSave={
		completed:[
				   [4879,0,0.058823529411764705],[5898,0,0.11764705882352941],[10522,0,0.1764705882352941],[11232,0,0.23529411764705882],[11428,0.032,0.23529411764705882],[12363,0,0.29411764705882354],
				   [13258,0,0.35294117647058826],[13747,0.0352,0.35294117647058826],[14289,0,0.411764705882353],[14849,0,0.4705882352941177],[15635,0.0388,0.4705882352941177],[16905,0,0.5294117647058824],
				   [17126,0.0324,0.5294117647058824],[17773,0.06959999999999995,0.5294117647058824],[17925,0.10119999999999994,0.5294117647058824],[19075,0,0.5882352941176471],[22465,0,0.6470588235294118],
				   [23206,0.038,0.6470588235294118],[23999,0,0.7058823529411765],[24654,0,0.7647058823529412],[25849,0,0.823529411764706],[26477,0,0.8823529411764707],[27673,0,0.9411764705882354],[31231,0,1]
		],
		words:[4,6,5,6],
		difficulty:0
	}
	
	this.setLevel=function(difficulty,level){
		if(!this.fileConfig){
			alert('configuration file not loaded !');
			return;
		}
		var obj=false;
		obj=this.fileConfig.Topics[difficulty];
		if(!obj){
			alert('Topic set to "'+difficulty+'" failed !');
			return;
		}
		this.Background=obj.Background;
		
		obj=obj.DifficultyLevels[level];
		if(!obj){
			alert('Level set to "'+level+'" failed !');
			return;
		}
		
		this.kayakDown=obj.kayakDown;
		this.riverSpeed=obj.riverSpeed;

		this.floatersDown=obj.riverSpeed*150;
		this.HintNum=obj.HintNum;
		this.HintDuration=obj.HintDuration;
		
		this.scorePerLetter=this.fileConfig.scorePerLetter;
		this.ElementNum=obj.ElementNum;
		
		this.scoreDiff=obj.scoreDiff;

		this.kayakSpeed=obj.kayakSpeed;
		if(obj.kayakUp)this.kayakUp=obj.kayakUp;else this.kayakUp=false;
	}
	
	this.loadResource=function(res){
		var ret=[];
		ret[0]=res[0];
		if((res[1].indexOf("http://")!==-1)||(res[1].indexOf("https://")!==-1))
			ret[1]=res[1];
		else
			ret[1]='js/games/kayak/assets/sound/'+res[1];
		if((res[2].indexOf("http://")!==-1)||(res[2].indexOf("https://")!==-1))
			ret[2]=res[2];
		else
			ret[2]='js/games/kayak/assets/sound/'+res[2];
		return(ret);
	}
	
	this.setBackground=function(value){
		alert(this.Background+' * '+value);
		this.Background=value;
	}
}